//
//  PhidgetDictionaryScanner.m
//  BoardRoom
//
//  Created by Phidgets on 2017-02-17.
//  Copyright © 2017 Phidgets. All rights reserved.
//

#import "PhidgetDictionaryScanner.h"

#define LENGTH 50
#define NUM_KEYS 1
@implementation PhidgetDictionaryScanner
+(NSMutableDictionary *)scan:(PhidgetDictionaryHandle)dictionary{
    NSMutableArray *keysArray = [[NSMutableArray alloc] init];
    NSMutableArray *valuesArray = [[NSMutableArray alloc] init];
    bool readingKeys = true;
    do
    {
        char buffer[LENGTH] = "";
        const char *lastString = (const char *)[[keysArray lastObject] cStringUsingEncoding:NSASCIIStringEncoding];
        PhidgetDictionary_scan(dictionary, lastString, buffer, LENGTH);
        if(buffer[0] == '\0')
            readingKeys = false;
        else{
            char *array[NUM_KEYS];
            int i = 0, j = 0;
            array[i] = strtok(buffer,"\n");
            while(array[i]!=NULL){
                if(i == NUM_KEYS-1)
                    break;
                array[++i] = strtok(NULL,"\n");
            }
            do{
                [keysArray addObject:[NSString stringWithFormat:@"%@",[NSString stringWithUTF8String:array[j++]]]];
            }while(j < i);
        }
    }while(readingKeys);
    
    for (int i = 0; i < keysArray.count; i++){
        char value[LENGTH];
        const char *key = (const char*)[[keysArray objectAtIndex:i] cStringUsingEncoding:NSASCIIStringEncoding];
        PhidgetDictionary_get(dictionary, key, value, LENGTH);
        [valuesArray addObject:[NSString stringWithFormat:@"%@",[NSString stringWithUTF8String:value]]];
    }
    NSMutableDictionary *pairs = [[NSMutableDictionary alloc] initWithObjects:valuesArray forKeys:keysArray];
    return pairs;
}
@end
